package settings;

import java.nio.file.Path;
import java.util.Locale;
import java.util.Set;

public interface Settings {

	public abstract void fireSettingsChanged(String name);

	public abstract void set(String name, String value);
	public abstract void set(String name, double value);
	public abstract void set(String name, int value);

	public abstract void set(String name, Locale l);

	public abstract void set(String name, String[] values);

	public abstract void set(String name, int[] values);

	public abstract void set(String name, boolean value);

	public abstract void set(String name, Path value);

	public abstract String getString(String name);

	public abstract int[] getIntArray(String name);

	public abstract String[] getStringArray(String name);

	public abstract Integer getInt(String name);

	public abstract boolean getBoolean(String name);

	public abstract Double getDouble(String name);

	public abstract Locale getLocale(String name);

	public abstract Set<String> getSettingsKeyset();

	public abstract String toString(String name);
	
	public abstract Path getPath(String name);

}