package singleInstance;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;


public class SingleInstance {
	private static ServerSocket serverSocket;
		
	private static int port;
	
	private SingleInstance() {
	}
	
	public static boolean isInstanceRunning(int port) {
		SingleInstance.port = port;
		try {
			serverSocket=new ServerSocket(port);
			return false;
		} catch (IOException e) {
			return true;
		}
	}
	
	public static void sendArgsToInstance(String[] args) {
		try {
			Socket socket=new Socket(InetAddress.getLocalHost(), port);
			ObjectOutputStream out=new ObjectOutputStream(socket.getOutputStream());
			out.writeObject(args);
			out.close();
		} catch (IOException e1) {
		}
	}
	
	public static void lock(final SingleInstanceHandler handler)  {
		
			new Thread(new Runnable() {
				
				@Override
				public void run() {
					try {
						while (true) {
							Socket receiveSocket =serverSocket.accept();
							
							ObjectInputStream in=new ObjectInputStream(receiveSocket.getInputStream());
							
							Object o;
							try {
								o = in.readObject();
								if (o instanceof String[]) {
									String[] args0=(String[])o;
									handler.passArguments(args0);
								}
							} catch (ClassNotFoundException e) {
								throw new IllegalArgumentException("illegal arguments");
							}
							
							in.close();
						}
					} catch (IOException e) {
						
					}
					
				}
			}).start();
		
		
	}
}
